"""AdditionalForcesObtainedFrom"""

from __future__ import annotations

from enum import Enum
from typing import TYPE_CHECKING

from mastapy._private._internal.python_net import python_net_import

_ADDITIONAL_FORCES_OBTAINED_FROM = python_net_import(
    "SMT.MastaAPI.SystemModel.AnalysesAndResults.StaticLoads.DutyCycleDefinition",
    "AdditionalForcesObtainedFrom",
)

if TYPE_CHECKING:
    from typing import Any, Type, TypeVar

    Self = TypeVar("Self", bound="AdditionalForcesObtainedFrom")
    CastSelf = TypeVar(
        "CastSelf",
        bound="AdditionalForcesObtainedFrom._Cast_AdditionalForcesObtainedFrom",
    )


__docformat__ = "restructuredtext en"
__all__ = ("AdditionalForcesObtainedFrom",)


class AdditionalForcesObtainedFrom(Enum):
    """AdditionalForcesObtainedFrom

    This is a mastapy class.

    Note:
        This class is an Enum.
    """

    @classmethod
    def type_(cls) -> "Type":
        return _ADDITIONAL_FORCES_OBTAINED_FROM

    LARGEST_MAGNITUDE = 0
    MEDIAN_VALUE = 1
    AVERAGE_VALUE = 2


def __enum_setattr(self: "Self", attr: str, value: "Any") -> None:
    raise AttributeError("Cannot set the attributes of an Enum.") from None


def __enum_delattr(self: "Self", attr: str) -> None:
    raise AttributeError("Cannot delete the attributes of an Enum.") from None


AdditionalForcesObtainedFrom.__setattr__ = __enum_setattr
AdditionalForcesObtainedFrom.__delattr__ = __enum_delattr
